# Relation Object

```json
{
  "id": "othermod",
  "namespace": "com.example",
  "version": "[1.0]",
  "repositories": ["repo1"],
  "flags": [],
  "links": ["https://example.com/othermod.json", "./othermod.json"],
  "conditions": {}
}
```

## Required properties

### id

This is the ID of the addon this relation refers to.

## Optional properties

### namespace

This is the [namespace](../concepts/namespaces.md) of the related addon. This property will be implicitly equal to the 
[namespace of the addon](addon.md#namespace), if it was not set explicitly.

### version

This is a [maven version range](../concepts/versioning.md#dependancy-version-requirement-specification) that specifies, which versions
of the related addon are targeted by this relation. You can either set this property or `semver`, but exactly one of them has to be set.

### semver

This is a [semver version range](https://github.com/semver/semver/pull/584) of supported versions of this relation.
It will only allow versions of the related addon, which have a valid semver version number, which is in this range.

### repositories

This is an array of [repository](repository.md) IDs. These are the repositories, from which AddonScript should try to get this relation from,
in the order as they are specified in the array. If this property is not set or the array is empty, AddonScript will try to resolve the relation by
the namespace from all defined repositories.

### flags

This is an array of [flags](../concepts/flags.md) for this relation. If this property is not present in a relation object, the relation will use the default flags.

### links

This is an array of [links](../concepts/links.md), which are pointing to an [AddonScript JSON](addon.md) file, that contains the related addon.
When resolving relations, AddonScript should try to getthe related addon from the first link in this array. If the link doesn't work or the version
of the linked addon is not in the version range of this relation, the next link should be tried or, if there is no link left, the addon should
be resolved from the [repositories](#repositories)

### conditions

This is a [conditions object](conditions.md). It can only be used, if the [optional flag](../concepts/flags.md) was set.
